


#ifndef  NONPREEMPTIVE_H		

#define  NONPREEMPTIVE_H yes



#define CONFIGURE_MAXIMUM_ENTRY_NUMBER    100

#include <time.h>


typedef void* (*function_type) (void*);


typedef struct nonpreemptive_entry_t {
  uint32_t duration;
  function_type entrypoint;
  void* arg;
} nonpreemptive_entry_t;



extern void nonpreemptive_active_wait(uint32_t duration);

extern uint32_t nonpreemptive_get_start_time(void);
extern uint32_t nonpreemptive_get_current_time(void);
extern int      nonpreemptive_get_current_entry(void);
extern uint32_t nonpreemptive_get_current_release_time(void);

extern void nonpreemptive_init(void);
extern void nonpreemptive_add_function(nonpreemptive_entry_t entry);
extern void nonpreemptive_add_array_function(nonpreemptive_entry_t entries [], int size);
extern void nonpreemptive_start(int iteration);
extern void nonpreemptive_stop(void);



#endif				


